using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA;

namespace SOAPClasses
{
    public class Computerm
    {
        computermBinding computerm;
        Binder binder;

        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public Computerm(Binder _binder)
        {
            binder = _binder;
        }


        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public Computerm(string url, string session)
        {
            binder = new Binder(url, session);
        }

        public string testForBug100958()
        {
            try
            {
                if (computerm == null)
                    computerm = (computermBinding)binder.InitBinding(typeof(computermBinding), true);
                partitionType[][] part = computerm.get_disk(new object());
                bool okFlag = false;
                foreach(partitionType[] disk in part)
                    foreach (partitionType p in disk)
                    {
                        if (p.blocks == null || p.inodes == null)
                            return "Exception: check of fix of bug 100958 failed for " + p.name + " mount point " + p.mount_point;
                        okFlag = true;
                    }
                if (!okFlag)
                    return "Exception: check of fix of bug 100958 : nothing fetched";                    
            }
            catch (System.Web.Services.Protocols.SoapException e)
            {
                return "Exception: " + e.Detail.InnerText;
            }
            return "Ok!";
        }

        public string testForBug100961()
        {
            try
            {
                if (computerm == null)
                    computerm = (computermBinding)binder.InitBinding(typeof(computermBinding), true);
                get_dateResponse d = computerm.get_date(new get_date());
                if (d == null)
                    throw new System.Exception("response is null");
                if (d.date == null)
                    throw new System.Exception("response.date is null");
                if (d.date.time == null)
                    throw new System.Exception("response.date.time is null");
                if (d.date.time_zone == null)
                    throw new System.Exception("response.date.time_zone is null");
                if (d.date.time == "")
                    throw new System.Exception("response.date.time == \"\"");
                if (d.date.time_zone == "")
                    throw new System.Exception("response.date.time_zone == \"\"");

                set_date sd = new set_date();
                sd.date = d.date;
                computerm.set_date(sd);

                time_zone[] tz = computerm.get_zones_info(new get_zones_info());
                if (tz == null)
                    throw new System.Exception("computerm.get_zones_info.response.time_zone == null");
                if (tz.Length == 0)
                    throw new System.Exception("computerm.get_zones_info.response.tz.Length == 0");
                if (tz[0].name == "")
                    throw new System.Exception("computerm.get_zones_info.response.tz[0].name == \"\"");
                return "Ok!";
            }
            catch (System.Web.Services.Protocols.SoapException e)
            {
                return "Exception: " + e.Detail.InnerText;
            }
            catch (System.Exception e)
            {
                return "Exception: " + e.Message;
            }
        }
    }
}