using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA;

namespace SOAPClasses
{
    public class ProcInfo
    {
        vzaproc_infoBinding pi;
        Binder binder;

        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public ProcInfo(Binder _binder)
        {
            binder = _binder;
        }


        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public ProcInfo(string url, string session)
        {
            binder = new Binder(url, session);
        }

        public string testForBug100773()
        {
            try
            {
                if (pi == null)
                    pi = (vzaproc_infoBinding)binder.InitBinding(typeof(vzaproc_infoBinding), true);
                Envm env = new Envm(binder);
                eidList eids = env.getEIDList(6);
                if (eids.Count == 0)
                    throw new System.Exception("no running CT on node");
                get5 args = new get5();
                args.eid = eids[0];
                getResponse2 r = pi.get(args);
                if (r.ps_info == null)
                    throw new System.Exception("r.ps_info == null");
                if (r.ps_info.process.Length == 0)
                    throw new System.Exception("r.ps_info.process.Length == 0");
                return "Ok!";
            }
            catch (System.Web.Services.Protocols.SoapException e)
            {
                return "Exception: " + e.Detail.InnerText;
            }
            catch (System.Exception e)
            {
                return "Exception: " + e.Message;
            }
        }

        // Search PID by command line
        public int getPID(string eid, string commandLine)
        {
            if (pi == null)
                pi = (vzaproc_infoBinding)binder.InitBinding(typeof(vzaproc_infoBinding), true);

            get5 args = new get5();
            args.eid = eid;
            getResponse2 r = pi.get(args);
            // search command index
            int idx = 0;
            int commandIdx = -1;
            foreach(string v in r.ps_info.param_id)
            {
                if (v == "command")
                {
                    commandIdx = idx;
                    break;
                }
                idx++;
            }
            if (commandIdx < 0)
                throw new System.Exception("ivalid response from vzaproc_info/get: can't find command");
            // Search command
            foreach(ps_infoTypeProcess proc in r.ps_info.process)
            {
                string s = System.Text.ASCIIEncoding.ASCII.GetString(proc.param[commandIdx]).Trim();

                if (s == commandLine)
                    return proc.pid;
            }
            throw new System.Exception("process \""+ commandLine + "\" not found");
        }
    }
}