using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA;

namespace SOAPClasses
{
   public class Resourcem
    {
       Binder binder;
       VZA.resourcemBinding resourcem; 

       ///<summary>
       ///  Constructor
       /// <param name="sURL">URL</param>
       /// <param name="sess">session</param>
       ///</summary>
       public Resourcem(Binder _binder)
       {
           binder = _binder;
       }

       ///<summary>
       ///  Constructor
       /// <param name="sURL">URL</param>
       /// <param name="sess">session</param>
       ///</summary>
       public Resourcem(string url, string session)
       {
           binder = new Binder(url, session);
       }

       public string setPool()
       {
           try
           {
               if (resourcem == null) resourcem = (resourcemBinding)binder.InitBinding(typeof(resourcemBinding));
               resource_ip_poolType resPoolIPType = new resource_ip_poolType();
               resPoolIPType.Items = new object[1];
               resPoolIPType.type = "resource_ip";
               resource_ip_poolTypeIp_range ipRange = new
resource_ip_poolTypeIp_range();
               ipRange.end_ip = "10.30.1.5";
               ipRange.start_ip = "10.30.1.1";
               resPoolIPType.Items[0] = ipRange;
               resource_poolType[] resPoolType = new resource_poolType[1];
               resPoolType[0] = resPoolIPType;

               resourcem.set_pool(resPoolType);
               return "OK";
           }
           catch (System.Web.Services.Protocols.SoapException e)
           {
               return "Exception: " + e.Detail.InnerText;
           }
       }
    }
}
