using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA;

namespace SOAPClasses
{
    public class ServerGroup
    {
        server_groupBinding sgb;
        Binder binder;

        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public ServerGroup(Binder _binder)
        {
            binder = _binder;
        }


        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
        public ServerGroup(string url, string session)
        {
            binder = new Binder(url, session);
        }


        public string testForBug100968()
        {
            try
            {
                if (sgb == null)
                    sgb = (server_groupBinding)binder.InitBinding(typeof(server_groupBinding), true);
                voc_idType[] vocId = new voc_idType[0];
                vocabularyType[] vocList = sgb.get_vocabulary(vocId);
                TracePointsChecker tp = new TracePointsChecker();

                tp.add("voc list iterations");
                tp.add("voc list iterations VZLServerGroup found");
                tp.add("parameter-iterations");
                tp.add("parameter-iterations-server_group.add-found");
                tp.add("category-iterations");
                tp.add("category-iterations-auth_only_realm_type-found");

                foreach (vocabularyType voc in vocList)
                {
                    tp.trace("voc list iterations");
                    if (voc.name == null)
                        return "Exception: check of fix of bug 100968 : voc.name == null";
                    if (voc.name == "VZLServerGroup")
                    {
                        tp.trace("voc list iterations VZLServerGroup found");
                        // Check for this voc only...
                        if (voc.parameter == null)
                            return "Exception: check of fix of bug 100968 : voc.parameter == null";
                        foreach (voc_parameterType par in voc.parameter)
                        {
                            tp.trace("parameter-iterations");
                            if (par.id == "server_group.add")
                            {
                                tp.trace("parameter-iterations-server_group.add-found");
                                if (par.category.Length!=1)
                                    return "Exception: check of fix of bug 100968 : par.category.Length()!=1";
                            }
                        }
                    }

                    if (voc.name == "VZLAuthEngine")
                    {
                        foreach (voc_parameterType par in voc.category)
                        {
                            tp.trace("category-iterations");
                            if (par.id == "auth_only_realm_type")
                            {
                                tp.trace("category-iterations-auth_only_realm_type-found");
                            }
                        }
                    }

                }
                string r = tp.report();
                if (r!="")
                    return "Exception: check of fix of bug 100968 : " + r;
            }
            catch (System.Web.Services.Protocols.SoapException e)
            {
                return "Exception: " + e.Detail.InnerText;
            }
            return "Ok!";
        }
    }
}