using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA;
using System.Xml;
using System.IO;
using System.Collections;

namespace SOAPClasses
{
   public class Systemm
    {
       systemBinding system;
       Binder binder;

       ///<summary>
       ///  Constructor
       /// <param name="sURL">URL</param>
       /// <param name="sess">session</param>
       ///</summary>
       public Systemm(Binder _binder)
       {
           binder = _binder;
       }

        ///<summary>
        ///  Constructor
        /// <param name="sURL">URL</param>
        /// <param name="sess">session</param>
        ///</summary>
       public Systemm(string url, string session)
        {
            binder = new Binder(url, session);
            
        }

        ///<summary>
        /// Method to infrastructure parameters from system configuration
        /// <returns>
        /// <para>Returns parameters if getting was successful or "Exception" if not.</para>
        /// </returns>
        ///</summary>
        public string getVocabulary(string[] categories,string[] names,string[] parameters)
        {
            try
            {
                if (system == null) system = (systemBinding)binder.InitBinding(typeof(systemBinding), false);
                string result="";
                get_vocabulary getVocabulary=new get_vocabulary ();
                getVocabulary.name =names;
                getVocabulary.category = categories;
                getVocabulary.parameter= parameters;
                vocabularyType[] data = system.get_vocabulary(getVocabulary);
                foreach (vocabularyType type in data)
                {
                    result += "\n Category: " + type.category + " Name: " + type.name ;
                    foreach (voc_parameterType param in type.parameter)
                        result += " Param :\n\t ID=" + param.id + " Type=" + param.type + " Data=" + param.data.ToString() + " Measure=" + param.measure + " Max=" + param.max;          
                }

                return result;
            }
            catch (System.Web.Services.Protocols.SoapException e)
            {
                return "Exception: " + e.Detail.InnerText;
            }
        }

    }
}
